package proyecto.Android.webService.Actions;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;
import java.net.URLConnection;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.servlet.ServletContext;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts2.ServletActionContext;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.springframework.web.context.WebApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;

import proyecto.Android.webService.persistencia.BookVO;
import proyecto.Android.webService.persistencia.FotosVO;
import proyecto.Android.webService.persistencia.PerfilVO;

import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.validator.annotations.RequiredFieldValidator;
import com.opensymphony.xwork2.validator.annotations.Validation;

/**
 * Action para Cargar PDF informacion y manual
 * 
 * @autor Matías Huéscar Muñoz (ELIMCO SISTEMAS)
 * 
 */
@Validation
public class CargaFotoPerfilAction extends ActionSupport {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	protected Log log = LogFactory.getFactory().getInstance(this.getClass());

	private String tipo;

	private String parametroJSON;
	private String nombreFoto;

	private File archivo;
	private String archivoContentType;
	private String archivoFileName;
	private String datos = "";
	private String ruta = "";
	private File archivoDes;
	private String texto;
	private String error;

	public CargaFotoPerfilAction() {

	}

	public String execute() {
		return SUCCESS;
	}

	/**
	 * 
	 * @param nombreFoto
	 * @param id_usuario
	 * @param pathfoto
	 * @return
	 */
	public String guardaFotos(String nombreFoto, Integer id_usuario,
			String pathfoto) {
		String res = "ok";

		System.out.println("5º Entra en actualizacionVisibles");
		ServletContext context = ServletActionContext.getServletContext();
		WebApplicationContext wac = WebApplicationContextUtils
				.getRequiredWebApplicationContext(context);
		SessionFactory sessionFactory = (SessionFactory) wac
				.getBean("defaultSessionFactory");
		Session session = null;

		try {
			session = sessionFactory.openSession();
			session.beginTransaction();
			FotosVO foto = new FotosVO();
			
			String hql = "select bk From BookVO bk where bk.id_usuario="
					+ id_usuario;

			pathfoto="res/ftp/"+id_usuario+"/"+nombreFoto;

			PerfilVO editarPerfil = (PerfilVO) session.load(PerfilVO.class,
					id_usuario);
			if (editarPerfil != null) {

				editarPerfil.setPathFoto(pathfoto);
				session.update(editarPerfil);
				session.beginTransaction().commit();
			}

		} catch (Exception e) {
			// TODO: handle exceptionç
			session.beginTransaction().rollback();
			System.out.println("fallo en importar fotoPERFIL bd" + e);
			res = "fallo";
		}

		return res;

	}

	/**
	 * Realiza la copia comprueba que el archivo origen sea de tipo pdf
	 * nombreFoto
	 * 
	 * @author Matías Huéscar Muñoz
	 */
	public String importarFoto() {

		InitialContext context;
		Context envContext;
		String res;

		try {

			context = new InitialContext();
			envContext = (Context) context.lookup("java:comp/env");
			ruta = (String) envContext.lookup(tipo);
			/*
			 * hacemos la pruba de crear la carpeta y introducir la foto tengo
			 * que recordar de meter este metodo a la hora de crear un usuario
			 */
			
			File directorio_usuario = new File(ruta);
			// guardo la carpeta en la bd
			BookVO book = new BookVO();

			Integer id_usuario = Integer.parseInt(parametroJSON);

			// String resultado =guardarCarpeta(ruta,id_usuario);

			// System.out.println(resultado);

			System.out.println(ruta);
			System.out.println(directorio_usuario);
			nombreFoto="_FotoPerfilUsuario_";
			//directorio_usuario.mkdir();
			//ruta = ruta +"//"+parametroJSON+"//"+parametroJSON + nombreFoto + ".jpg";

			
			String filename= parametroJSON +nombreFoto + ".jpg";
			//ruta = ruta + parametroJSON + nombreFoto + ".jpg";
			String filename2 ="//"+parametroJSON+"//"+filename;
			ruta = ruta+ "//"+ parametroJSON + "//"+filename;
			
			
			guardaFotos(filename, id_usuario, ruta);

			copiarFichero(archivo, filename2);
			
			
			
			// Guardar la foto en la bd;

			guardaFotos(filename, id_usuario, ruta);

			
			// Guardar la foto en la bd;

			
			copiarFichero(archivo, filename2);
			
			archivoDes = new File(ruta);
			System.out.println(ruta);

			/**
			 * recupero la carpeta y guardo la imagen con ifoto
			 */

			if (archivoContentType.toUpperCase().indexOf("JPEG") != -1) {

				//copiarFichero(archivo, archivoDes);

				BufferedReader entrada = new BufferedReader(new FileReader(
						archivo));
				if (archivoContentType.equals("text/plain")) {
					String aux;
					while ((aux = entrada.readLine()) != null) {
						datos += aux + "\n";

					}
				}
			}

			else {
				if (tipo.toUpperCase().indexOf("MANUAL") != -1) {
					texto = "error en manual.pdf";
				} else {
					texto = "error en información.pdf";
				}
				return "failure";
			}
		} catch (Exception e) {
			error = e.getLocalizedMessage();
			return "failure";

		}

		return SUCCESS;
	}

	public void setTipo(String tipo) {
		this.tipo = tipo;
	}

	public String getError() {
		return error;
	}

	/**o
	 * get de file
	 * 
	 * @return archivo de tipo File
	 * @author Matías Huéscar Muñoz
	 */
	public File getArchivo() {
		return archivo;
	}

	/**
	 * set de archivo
	 * o
	 * @param archivo
	 *            de tipo file
	 * @author Matías Huéscar Muñoz
	 */
	@RequiredFieldValidator(message = "Introduzca un archivo JPG")
	public void setArchivo(File archivo) {
		this.archivo = archivo;
	}

	/**
	 * get de String con el tipo de archivo
	 * 
	 * @return String con el valor del tipo de archivo
	 * @author Matías Huéscar Muñoz
	 */
	public String getArchivoContentType() {
		return archivoContentType;
	}

	/**
	 * set de la variable archivoContentType que contiene el tipo de archivo
	 * 
	 * @param archivoContentType
	 * @author Matías Huéscar Muñoz
	 */
	public void setArchivoContentType(String archivoContentType) {
		this.archivoContentType = archivoContentType;
	}

	/**
	 * get de String con el nombre del archivo
	 * 
	 * @return
	 * @author Matías Huéscar Muñoz
	 */
	public String getArchivoFileName() {
		return archivoFileName;
	}

	/**o
	 * 
	 * @param archivoFileName
	 * @author Matías Huéscar Muñoz public void setArchivoFileName(String
	 *         archivoFileName) { this.archivoFileName = archivoFileName; }
	 * 
	 *         /**
	 * 
	 * @return
	 * @author Matías Huéscar Muñoz
	 */
	public String getDatos() {
		return datos;
	}

	/**
	 * 
	 * @param datos
	 * @author Matías Huéscar Muñoz
	 */
	public void setDatos(String datos) {
		this.datos = datos;
	}

	/**
	 * 
	 * @return
	 * @author Matías Huéscar Muñoz
	 */
	public String gettexto() {
		return this.texto;
	}

	public String gettipo() {
		return this.tipo;
	}

	public String getNombreFoto() {
		return nombreFoto;
	}

	public void setNombreFoto(String nombreFoto) {
		this.nombreFoto = nombreFoto;
	}

	public String getParametroJSON() {
		return parametroJSON;
	}

	public void setParametroJSON(String parametroJSON) {
		this.parametroJSON = parametroJSON;
	}

	/**
	 * Realiza la coia de un archivo origen en un archivo destino
	 * 
	 * @param src
	 *            de tipo File
	 * @param dst
	 *            de tipo File
	 * @throws Exception
	 * @author Matías Huéscar Muñoz
	 */

	
	public void copiarFichero(File src, String nombre_fichero) throws Exception {
		System.out.println("Entra en copiarFichero");
		byte[] buf = new byte[2048];
		int len;
		String user = "ftp";
       String pass = "ftp";
       String server = "192.168.1.5";
       String remoteNombre_archivo = "//"+nombre_fichero;
       
		try {
				InputStream in = new FileInputStream(src);
				URL url = new URL("ftp://" + user + ":" + pass + "@" + server + remoteNombre_archivo + ";type=i");
	            URLConnection urlc = url.openConnection();
	            OutputStream os = urlc.getOutputStream();
			
			
			
           
         //  OutputStream os = urlc.getOutputStream();
          // OutputStream out = new FileOutputStream(dst);
			
		
			///metodo inicial
			/* Creo los flujos de entrada y salida. 
			InputStream in = new FileInputStream(src);
			OutputStream out = new FileOutputStream(dst);
			 */
			/*
			 * Mientras haya datos en el fichero de entrada. Los leo del origen
			 * y los escribo en el destino.
			 */
			while ((len = in.read(buf)) > 0)
				//out.write(buf, 0, len);
				os.write(buf, 0, len);
			/* Cierro los streams. */
			in.close();
			//out.close();
			os.close();
		} catch (FileNotFoundException e) {
			/*throw new Exception(
					"Origen o destino erroneos en copia de ficheros. "
							+ e.toString());*/
		System.out.println("Origen o destino erroneos en copia de ficheros. "+e);
		} catch (IOException e) {
			System.out.println("Error en la copia de fichero.. "+e);
			throw new Exception("Error en la copia de fichero.");

		}

	
	
	}
}

