package proyecto.Android.webService.Modelo;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletContext;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts2.ServletActionContext;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.springframework.web.context.WebApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;

import proyecto.Android.webService.persistencia.ConfiguracionVO;
import proyecto.Android.webService.persistencia.DistanciasVO;
import proyecto.Android.webService.persistencia.LocalizacionVO;
import proyecto.Android.webService.persistencia.Visibles_androidVO;

public class ActualizaLocalizacionManager {
	protected Log log = LogFactory.getFactory().getInstance(this.getClass());
	private static List<LocalizacionVO> pendientesProcesar = new ArrayList<LocalizacionVO>();
	private LocalizacionVO localizacionUsuario;
	private static boolean bandera = false;
	

	public ActualizaLocalizacionManager() {
		System.out.println("Entra en la clase Actualiza Localizacion");

	}

	

	public static boolean isBandera() {
		return bandera;
	}

	public static void setBandera(boolean bandera) {
		ActualizaLocalizacionManager.bandera = bandera;
	}

	public LocalizacionVO getLocalizacionUsuario() {
		return localizacionUsuario;
	}

	public void setLocalizacionUsuario(LocalizacionVO localizacionUsuario) {
		this.localizacionUsuario = localizacionUsuario;
	}

	public static List<LocalizacionVO> getPendientesProcesar() {
		return pendientesProcesar;
	}

	public static void setPendientesProcesar(
			List<LocalizacionVO> pendientesProcesar) {
		ActualizaLocalizacionManager.pendientesProcesar = pendientesProcesar;
	}

	public static void addloalizacionPendientesProcesar(LocalizacionVO aux) {
		System.out.println("4º añade una localizacion a la lista "
				+ aux.toString());
		pendientesProcesar.add(aux);
		System.out.println("+-+StaticaPeticiones"+pendientesProcesar.size());
	}

	public static LocalizacionVO removeloalizacionPendientesProcesar() {
		System.out.println("7º removelocalizacion ");
		LocalizacionVO porprocesar = pendientesProcesar.remove(0);
		System.out.println("+++StaticaPeticiones"+pendientesProcesar.size());
		return porprocesar;
	}

	/**
	 * Metodo encargado de relizar las operaciones necesarias para actualozar la
	 * tabla visibles;
	 * 
	 * @return
	 */
	public String actualizacionVisibles() {
		System.out.println("5º Entra en actualizacionVisibles");
		ServletContext context = ServletActionContext.getServletContext();
		WebApplicationContext wac = WebApplicationContextUtils
				.getRequiredWebApplicationContext(context);
		SessionFactory sessionFactory = (SessionFactory) wac
				.getBean("defaultSessionFactory");
		Session session = null;

		LocalizacionVO localizacionUsuario = null;

		List<LocalizacionVO> amigosYcompatibles = new ArrayList<LocalizacionVO>();

		String res = "Success";
		setBandera(true);
		System.out.println("6ª cierra la bandera true");

		while (!getPendientesProcesar().isEmpty()) {
			try {
				localizacionUsuario = (LocalizacionVO) removeloalizacionPendientesProcesar();
				boolean control;
				session = sessionFactory.openSession();
				session.beginTransaction();

				// actualizo la localizacion en la tabla
				control = actualizaLocalizacion(session, localizacionUsuario);

				// obtengo la lista de amigos compatibes
				if (control) {
					amigosYcompatibles = getListaAmigosyCompatibles(session,
							localizacionUsuario);
				}
				System.out.println(" amigosYcompatibles size:"
						+ amigosYcompatibles.size());
				System.out.println(" amigosYcompatibles contenido:"
						+ amigosYcompatibles.toString());
				session.beginTransaction().commit();
				session.flush();
				session.close();

				if (!amigosYcompatibles.isEmpty()) {
					// actualizamos la distancia relativa de usuario con
					// respecto sus amigos
					System.out.println("10 º actualizaDistancias ");
					res = actualizadistancias(localizacionUsuario,
							amigosYcompatibles, session);

				}
				// construimos o actualizamos la tabla visibles
				// System.out.println("actualizaAmigosVisiblesRadio");
				// res = actualizaAmigosVisiblesRadio(localizacionUsuario,
				// session);

			}

			catch (Exception e) {
				// TODO: handle exception

				System.out.println("FALLO actualizacionVisibles" + e);
				setBandera(false);
				res = "failure";

				session.getTransaction().rollback();
			}

		}

		// session.getTransaction().commit();
		// session.flush();
		// session.close();

		System.out.println("levanta la bandera true");
		setBandera(false);
		return res;
	}

	/**
	 * proceso que inicializa la actualizacion de un usuario
	 * 
	 * @param aux
	 * @return
	 */
	public boolean procesoActualizacion(LocalizacionVO aux) {
		System.out.println("3º Entra en procesoActualizacion");
		boolean res = true;
		LocalizacionVO lu;
		try {
			addloalizacionPendientesProcesar(aux);
			while (bandera) {
			}
			actualizacionVisibles();

		} catch (Exception e) {
			// TODO: handle exception
			System.out
					.println("procesoActualizacion Entra en el catch es decir puede fallar");
			res = false;
		}

		return res;

	}

	/**
	 * Metodo encargado de actualizar la distancia de un usuario con respecto
	 * sus amigos dado el usuario y la lista de amigos
	 * 
	 * @param localizacionUsuario
	 * @param amigosYcompatibles
	 */
	public String actualizadistancias(LocalizacionVO localizacionUsuario,
			List<LocalizacionVO> amigosYcompatibles, Session session1) {
		ServletContext context = ServletActionContext.getServletContext();
		WebApplicationContext wac = WebApplicationContextUtils
				.getRequiredWebApplicationContext(context);
		SessionFactory sessionFactory = (SessionFactory) wac
				.getBean("defaultSessionFactory");
		Session session = null;

		System.out.println("11º Entra en actualizaDistancias");
		System.out.println("12º actualizo o creo distancia localizacionUsuario"
				+ localizacionUsuario.toString());
		System.out.println("13º Entra amigosYcompatibles "
				+ amigosYcompatibles.toString());

		Integer id_user = localizacionUsuario.getId_usuario();

		Iterator<LocalizacionVO> iteradorAmigo = amigosYcompatibles.iterator();
		Integer distancia;
		Integer id_user_destino;

		String res = "success";

		List<DistanciasVO> auxiliar = new ArrayList<DistanciasVO>();
		List<Visibles_androidVO> listaEnviar = new ArrayList<Visibles_androidVO>();
		List<Visibles_androidVO> listaBorrar = new ArrayList<Visibles_androidVO>();
		try {
			session = sessionFactory.openSession();
			
			///Integer radio = getRadio(id_user, session);
			Integer radio=100000;
			LocalizacionVO aux = new LocalizacionVO();
			while (iteradorAmigo.hasNext()) {
				aux = (LocalizacionVO) iteradorAmigo.next();
				id_user_destino = aux.getId_usuario();
				if (!localizacionUsuario.equals(aux)) {
					if (id_user != id_user_destino) {
//calcula la distancia la da en km
					
						//prueba mhm
						distancia = localizacionUsuario.calculoDistancia(aux);
						
						
						
						
						DistanciasVO daux = new DistanciasVO();
						daux.setId_usuario(id_user);
						daux.setId_user_destino(id_user_destino);
						daux.setDistancia(distancia);

						System.out
								.println("15º actualizo o creo distancia con entre dos usuarios "
										+ aux.toString()
										+ " "
										+ daux.toString());

						session.beginTransaction();

						Visibles_androidVO visible_mandar = new Visibles_androidVO();
						visible_mandar.setId_usuario(id_user);
						visible_mandar
								.setId_usuario2(daux.getId_user_destino());

						//	radio= 10000;
						// guardamos  la distancia
						// tengo ue comprobar no puedo guardar siempre por que
						// desbordaria la tabla
						auxiliar.add(daux);
						// aqui deveria ir actualizando la distancia puedo
						// guardarlas o no si quiero tener un historico

						Integer id_distancia = get_id_Distancias(daux, session);
						if (id_distancia != null) {
							DistanciasVO actualizar = (DistanciasVO) session
									.load(DistanciasVO.class, id_distancia);
							if (actualizar != null) {
								System.out
										.println("!!! actualizo la tabla distancias");
								actualizar.setDistancia(distancia);
								session.update(actualizar);
							}
						} else {
							System.out
									.println("!!! guardo un nuevo usuario en la tabla distancias");
							session.saveOrUpdate(daux);
						}
						//en metros
						// guardo o actualizo a los usuarios que van a entrar en
						// la l
						System.out.println("radio "+radio);
						System.out.println("distancia "+distancia);
						
						
						if (distancia <= radio) {
							System.out.println("añade a la tabla visibles ");

							listaEnviar.add(visible_mandar);
							// cambio realizado guardamos el la distancia;
							System.out.println("Distancia= " + distancia);
							Integer id_relacion1 = get_id_Visibles_Android(
									visible_mandar, session);
							if (id_relacion1 != null) {
								Visibles_androidVO visibleActGuardar = (Visibles_androidVO) session
										.load(Visibles_androidVO.class,
												id_relacion1);
								// si existe es que el usuario ya estaba y puedo
								// no existe lo añado
								if (visibleActGuardar == null)
									session.save(visible_mandar);
								else
									System.out
											.println("!!!quiere decir que ya estab en la lista y sigue estando en el radio de ser visualizado");
							}
							// por aqui cuando no carga el id_relacion por que
							// no existe pero guarda
							else
								session.save(visible_mandar);
						}
						// aqui elimino los usuarios que han salido del rango
						// del radio
						else {
							System.out
									.println("aqui borraria los que tuviesen un radio menor ");
							// miro el di del objeto y lo borro
							listaBorrar.add(visible_mandar);
							Integer id_relacion = get_id_Visibles_Android(
									visible_mandar, session);
							if (id_relacion != null) {
								Visibles_androidVO visibleBorrar = (Visibles_androidVO) session
										.load(Visibles_androidVO.class,
												id_relacion);
								if (visibleBorrar != null) {
									session.delete(visibleBorrar);
									System.out.println("!!! Borra "
											+ visibleBorrar);
								}
							}
							System.out
									.println("aqui no borra por que no estaba en la tabla pero no inserta");

						}// final del else no tocar funciona
						session.getTransaction().commit();
						session.clear();
					}

				}
			}

		} catch (Exception e) {
			// TODO: handle exception
			System.out.println("fallo en actualiza distancia " + e);
			session.getTransaction().rollback();
			setBandera(false);
			res = "failure";
		}

		System.out.println("lista de calculo de distancias" + auxiliar.size()
				+ " " + auxiliar.toString() + " ");
		System.out.println("lista de calculo de listaEnviar"
				+ listaEnviar.size() + " " + listaEnviar.toString() + " ");
		System.out.println("lista de calculo de listaBorrar"
				+ listaBorrar.size() + " " + listaBorrar.toString() + " ");
		session.beginTransaction().commit();
		session.flush();
		session.close();
		return res;
	}

	/**
	 * devuelve el radio de visualizacion que tiene configurado el usuario
	 * 
	 * @param id
	 * @param session
	 * @return
	 */
	public Integer getRadio(Integer id, Session session) {
		System.out.println("14º Entra En getRadio");
		Integer radio = 500;
		try {
			String hql = "from ConfiguracionVO con where con.id_usuario=" + id;
			List<ConfiguracionVO> l = session.createQuery(hql).list();
			radio = l.get(0).getRadio();
			System.out.println("radio " + radio);
		} catch (Exception e) {
			// TODO: handle exception
			System.out.println("peta  En getRAdio");

		}

		return radio;

	}

	/**
	 * Metodo que actualiza la coordenas de latitud y longitud ;
	 * 
	 * @param session
	 * @param localizacionUsuario
	 * @return
	 */
	public boolean actualizaLocalizacion(Session session,
			LocalizacionVO localizacionUsuario) {
		System.out.println(" Entra en actualiza localizacion");

		boolean res = true;

		try {

			System.out.println("id_usuario"
					+ localizacionUsuario.getId_usuario());

			System.out.println("8 º LocalizacionPorActualizar "
					+ localizacionUsuario);
			session.saveOrUpdate("id_usuario ", localizacionUsuario);

			session.getTransaction().commit();

			System.out.println("9º LocalizacionGuardada");

		} catch (Exception e) {
			// TODO: handle exception
			System.out.println("9º  Fallo LocalizacionGuardada" + e);
			res = false;
			session.getTransaction().rollback();

		} finally {
			return res;
		}

	}

	/**
	 * 
	 * @param session
	 * @param loc
	 * @return
	 */
	public List<LocalizacionVO> getListaAmigosyCompatibles(Session session,
			LocalizacionVO loc) {
		System.out.println("getListaAmigosyCompatibles");
		String Prueba = "from LocalizacionVO";
		List<LocalizacionVO> amigosYcompatibles = new ArrayList<LocalizacionVO>();
		
		
		//tengo que realizar las consutas teniendo en cuenta la tabla conectados!!!!!!!!!
		
		String sql = "select loc  from AmigosyPosiblesVO  ayp, LocalizacionVO loc  "
				+ "where ayp.id_usuario="
				+ loc.getId_usuario()
				+ " and loc.id_usuario=ayp.id_usuario2";
		//
		
		//

		String sql2 = "select loc  from AmigosyPosiblesVO  ayp, LocalizacionVO loc, ConectadosVO con "
				+ "where ayp.id_usuario="
				+ loc.getId_usuario()
				+ " and loc.id_usuario=ayp.id_usuario2 " +
				  "and ayp.id_usuario2=con.id_usuario";
		//

		try {
			amigosYcompatibles = session.createQuery(sql2).list();
		} catch (Exception e) {
			// TODO: handle exception
			System.out.println("erron" + e);
		}
		System.out.println("sale");
		return amigosYcompatibles;
	}

	/**
	 * 
	 * @param vaux
	 * @param session
	 * @return
	 */
	public Integer get_id_Visibles_Android(Visibles_androidVO vaux,
			Session session) {
		Integer res = null;
		Visibles_androidVO aux;
		try {
			String hql = "select ayp from Visibles_androidVO  ayp where ayp.id_usuario="
					+ vaux.getId_usuario()
					+ " and ayp.id_usuario2="
					+ vaux.getId_usuario2();

			aux = (Visibles_androidVO) session.createQuery(hql).uniqueResult();
			res = aux.getId_visible();
		} catch (Exception e) {
			// TODO: handle exception
			System.out.println("falla en idVisiblesAndroid " + e);
		}
		return res;

	}

	/**
	 * 
	 * @param daux
	 * @param session
	 * @return
	 */
	public Integer get_id_Distancias(DistanciasVO daux, Session session) {
		Integer res = null;
		DistanciasVO aux;
		try {
			String hql = "select dis from DistanciasVO dis "
					+ "where dis.id_usuario=" + daux.getId_usuario()
					+ " and dis.id_user_destino=" + daux.getId_user_destino();

			aux = (DistanciasVO) session.createQuery(hql).uniqueResult();
			res = aux.getId_distancia();
		} catch (Exception e) {
			// TODO: handle exception
			System.out.println("falla en id_Distancias" + e);
		}
		return res;

	}

	/**
	 * 
	 * @return
	 */

	public boolean metododePruebas() {
		// log.debug("+++ guardaLocalizacion");
		boolean res = true;

		ServletContext context = ServletActionContext.getServletContext();
		WebApplicationContext wac = WebApplicationContextUtils
				.getRequiredWebApplicationContext(context);
		SessionFactory sessionFactory = (SessionFactory) wac
				.getBean("defaultSessionFactory");
		Session session = null;

		try {

			LocalizacionVO localizacionUsuario = null;
			int cont = 1;
			String hql = "select rel  from RelacionesVO rel , Posibles_RelacionesVO pr where rel.id_usuario=pr.id_usuario";
			while (cont < 10) {

				session = sessionFactory.openSession();
				System.out.println("!eeeeeee" + cont);

				LocalizacionVO localizacion = new LocalizacionVO();
				localizacion.setId_usuario(cont * 200);
				localizacion.setLatitud(cont * 37);
				localizacion.setLongitud(cont * 841);

				session.beginTransaction().begin();

				session.saveOrUpdate("id_usuario", localizacion);

				System.out.println("!" + localizacion);

				DistanciasVO distancia = new DistanciasVO();
				distancia.setId_usuario(cont + 2);
				distancia.setId_user_destino(3 * cont);
				distancia.setDistancia(50 * cont);
				session.saveOrUpdate("id_distancia", distancia);

				System.out.println("!" + distancia);

				Visibles_androidVO visibles = new Visibles_androidVO();
				visibles.setId_usuario(cont);
				visibles.setId_usuario2(cont + 2);
				session.saveOrUpdate("id_visible", visibles);

				cont++;
				session.beginTransaction().commit();
				System.out.println("!" + visibles);
				// session.flush();
				session.flush();
				session.clear();

			}
			// String resultado =session.createQuery(hql).list().toString();
			// System.out.println("!"+resultado);
		} catch (Exception e) {
			// TODO: handle exception

			System.out.println("!" + e);
			res = false;

		}
		session.close();
		return res;
	}
	
	/**
	 * devuelve el radio de visualizacion que tiene configurado el usuario
	 * 
	 * @param id
	 * @param session
	 * @return
	 */
	public String setRadio(Integer id, Integer radio) {
		System.out.println("14º Entra En setRadio");
		ServletContext context = ServletActionContext.getServletContext();
		WebApplicationContext wac = WebApplicationContextUtils
				.getRequiredWebApplicationContext(context);
		SessionFactory sessionFactory = (SessionFactory) wac
				.getBean("defaultSessionFactory");
		Session session = null;
		//Integer radio = 500;
		String res="";
		try {
			session=sessionFactory.openSession();
			session.beginTransaction();
			ConfiguracionVO conf =(ConfiguracionVO)session.load(ConfiguracionVO.class,id);
			conf.setRadio(radio);
			session.update(conf);
			session.beginTransaction().commit();
			res="radio cambiado a :"+radio;
			
		} catch (Exception e) {
			// TODO: handle exception
			System.out.println("falla  En setRAdio"+e);
			res= "fallo al cambiar el radio";
		}
	session.flush();
	session.close();
	return res;
	}
	
	

}// final de clase
