package proyecto.Android.webService.Modelo;

import java.io.PrintWriter;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts2.ServletActionContext;
import org.apache.struts2.interceptor.ServletRequestAware;
import org.apache.struts2.interceptor.ServletResponseAware;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.springframework.web.context.WebApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;

import proyecto.Android.webService.persistencia.LocalizacionVO;
import proyecto.Android.webService.persistencia.UsuariosVO;

import com.opensymphony.xwork2.ActionSupport;

public class MuestraUsuariosManager extends ActionSupport implements ServletRequestAware, ServletResponseAware {

	protected Log log = LogFactory.getFactory().getInstance(this.getClass());
	private String usuario;
	private UsuariosVO usuarioVO;

	private HttpServletRequest request;
	private HttpServletResponse response;

	public MuestraUsuariosManager() {
		// TODO Auto-generated constructor stub
		try {
			Class.forName("com.mysql.jdbc.Driver");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public HttpServletRequest getRequest() {
		return request;
	}

	public void setRequest(HttpServletRequest request) {
		this.request = request;
	}

	public HttpServletResponse getResponse() {
		return response;
	}

	public void setResponse(HttpServletResponse response) {
		this.response = response;
	}
	public void setServletRequest(HttpServletRequest request){
        this.request = request;
      }

      public HttpServletRequest getServletRequest(){
        return request;
      }

      public void setServletResponse(HttpServletResponse response){
        this.response = response;
      }

      public HttpServletResponse getServletResponse(){
        return response;
      }

	public String execute() throws Exception {
		System.out.println("!!Entra en execute");
		try {
			this.getListaUsuarios();
			return SUCCESS;
		} catch (Exception e) {
			// TODO: handle exception
			log.info(e);
			return "failure";
		}

	}

	public String getUsuario() {
		return usuario;
	}

	public void setUsuario(String usuario) {
		this.usuario = usuario;
	}

	public UsuariosVO getUsuarioVO() {
		return usuarioVO;
	}

	public void setUsuarioVO(UsuariosVO usuarioVO) {
		this.usuarioVO = usuarioVO;
	}

	
	
	
	public boolean localizacion(String [] localizacion){
		log.debug("+++ guardaLocalizacion");
		ServletContext context = ServletActionContext.getServletContext();
		WebApplicationContext wac = WebApplicationContextUtils
				.getRequiredWebApplicationContext(context);
		SessionFactory sessionFactory = (SessionFactory) wac
				.getBean("defaultSessionFactory");
		Session session = sessionFactory.openSession();
		boolean res= false;
		System.out.println("localozacion"+localizacion.toString());
		try {
			LocalizacionVO aux = new LocalizacionVO();
			aux.setId_usuario(Integer.parseInt(localizacion[0]));
			aux.setLatitud(Integer.parseInt(localizacion[1]));			
			aux.setLongitud(Integer.parseInt(localizacion[2]));
			System.out.println("aux"+ aux.toString());
			session.saveOrUpdate("id_usuario", aux);
			session.flush();
			session.close();
			res= true;
			System.out.println("guardado");
		} catch (Exception e) {
			log.debug("!!!La lista de usuario no Existia");
			log.error(e);
			session.close();
			
		}
		return res;

		
	}
	
	
	
	
	public List<UsuariosVO> getListaUsuarios() {
		log.debug("+++ Lista de Categorias");
		ServletContext context = ServletActionContext.getServletContext();
		WebApplicationContext wac = WebApplicationContextUtils
				.getRequiredWebApplicationContext(context);
		SessionFactory sessionFactory = (SessionFactory) wac
				.getBean("defaultSessionFactory");
		Session session = sessionFactory.openSession();

		List<UsuariosVO> listaUsuarios = null;
		
		try {

			String hql = "from UsuariosVO order by id_usuario ";

			listaUsuarios = (List<UsuariosVO>) session.createQuery(hql).list();

			log.debug("!!!La lista de usuario existe");
			log.debug("contenido" + listaUsuarios.toString());
			session.close();
		} catch (Exception e) {
			log.debug("!!!La lista de usuario no Existia");
			log.error(e);

			session.close();

		}
		return listaUsuarios;
	}

	public void getUsuarios() {
		log.info("entra en getUSUarios");
		try {
			
			
			response.setCharacterEncoding("UTF8");
			response.setContentType("text/html");
			PrintWriter out = response.getWriter();
			out.write("");
			
			/* out.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 " +
                     "Transitional//EN\">\n" +
                     "<HTML>\n" +
                     "<HEAD><TITLE>Hello WWW</TITLE></HEAD>\n" +
                     "<BODY>\n" +
			 "<H1>Hello ALberto </H1>\n");*/
		
		out.flush();	
			
			
			List<UsuariosVO> prueba = getListaUsuarios();

			Iterator<UsuariosVO> it = prueba.iterator();

			while (it.hasNext()) {
				out.write("<br> " + it.next().toString());
				//log.info("Usuario" + it.next().toString());
				
			}
			out.flush();

			
			
			out.write("<br><a href='index.action'> Pulse para volver</a>");
			
			//out.write( "</BODY></HTML>");
		} catch (Exception e) {
			// TODO: handle exception
			log.info("Esto esta petando");
			log.error(e);
		}
		
	}

	
	
	
	
	public List<LocalizacionVO> getLocalizaciones(String auxParameter){
		
		log.debug("+++ Lista de Categorias");
		ServletContext context = ServletActionContext.getServletContext();
		WebApplicationContext wac = WebApplicationContextUtils
				.getRequiredWebApplicationContext(context);
		SessionFactory sessionFactory = (SessionFactory) wac
				.getBean("defaultSessionFactory");
		Session session = sessionFactory.openSession();

		String[] aux =auxParameter.split("x");
		String id= aux[0];
		System.out.println("!!"+aux[0].toString()+" "+id);
		
		List<LocalizacionVO> listaUsuarios = null;
		
		try {

			String hql = "from LocalizacionVO order by id_usuario ";
			
			String hql2="select distinct loc from Visibles_androidVO  vi, LocalizacionVO  loc, ConectadosVO con where vi.id_usuario="+id+" and vi.id_usuario2=loc.id_usuario and loc.id_usuario=con.id_usuario";
			
			
			
			listaUsuarios = (List<LocalizacionVO>) session.createQuery(hql2).list();

			log.debug("!!!La lista de usuario existe");
			log.debug("contenido" + listaUsuarios.toString());
			session.close();
		} catch (Exception e) {
			log.debug("!!!La lista de usuario no Existia");
			log.error(e);

			session.close();

		}
		return listaUsuarios;
	}
		
		
		
		
	}
	
	
	
	
	
	
	
	
	
	
	

